## multipath-tools 0.14.3

=== multipathd/Makefile ===
include ../Makefile.inc

EXEC     := multipathd
CLI      := multipathc
MANPAGES := multipathd.8

CPPFLAGS += -I$(multipathdir) -I$(mpathutildir) -I$(mpathpersistdir) -I$(mpathcmddir) -I$(thirdpartydir) \
	-DBINDIR='"$(bindir)"' $(SYSTEMD_CPPFLAGS)

#
# debugging stuff
#
#CPPFLAGS += -DLCKDBG
#CPPFLAGS += -DLOGDBG

CFLAGS += $(BIN_CFLAGS)
LDFLAGS += $(BIN_LDFLAGS)

CLI_LIBDEPS	:=  -L$(mpathutildir) -lmpathutil -L$(mpathcmddir) -lmpathcmd \
		-ludev -ldl -lurcu -lpthread $(SYSTEMD_LIBDEPS)
LIBDEPS		:= -L$(multipathdir) -lmultipath -L$(mpathpersistdir) -lmpathpersist \
	  	-ldevmapper $(CLI_LIBDEPS)

ifeq ($(READLINE),libedit)
RL_CPPFLAGS	:= -DUSE_LIBEDIT
RL_LIBDEPS	:= -ledit
# See comment in multipathc.c
ifeq ($(shell sed -En 's/.*\<Function\s*\*rl_completion_entry_function;.*/yes/p' /usr/include/editline/readline.h),yes)
RL_CPPFLAGS += -DBROKEN_RL_COMPLETION_FUNC
endif
endif
ifeq ($(READLINE),libreadline)
RL_CPPFLAGS	:= -DUSE_LIBREADLINE
RL_LIBDEPS	:= -lreadline
endif

CLI_OBJS := multipathc.o cli.o
OBJS := main.o pidfile.o uxlsnr.o uxclnt.o cli.o cli_handlers.o waiter.o \
       dmevents.o init_unwinder.o purge.o
ifeq ($(FPIN_SUPPORT),1)
OBJS += fpin_handlers.o
endif

all : $(EXEC) $(CLI) $(MANPAGES) $(EXEC).service $(EXEC).socket $(EXEC)-queueing.service

$(EXEC): $(OBJS) $(multipathdir)/libmultipath.so $(mpathcmddir)/libmpathcmd.so
	@echo building $@ because of $?
	$(Q)$(CC) $(CFLAGS) $(OBJS) $(LDFLAGS) -o $(EXEC) $(LIBDEPS)

multipathc.o:	multipathc.c
	$(Q)$(CC) $(CPPFLAGS) $(RL_CPPFLAGS) $(CFLAGS) -Wno-unused-parameter -c -o $@ $<

$(CLI):  $(CLI_OBJS)
	@echo building $@ because of $?
	$(Q)$(CC) $(CFLAGS) $(CLI_OBJS) $(LDFLAGS) -o $@ $(CLI_LIBDEPS) $(RL_LIBDEPS)

cli_handlers.o:	cli_handlers.c
	$(Q)$(CC) $(CPPFLAGS) $(CFLAGS) -Wno-unused-parameter -c -o $@ $<

install:
	$(Q)$(INSTALL_PROGRAM) -d $(DESTDIR)$(bindir)
	$(Q)$(INSTALL_PROGRAM) -m 755 $(EXEC) $(DESTDIR)$(bindir)
	$(Q)$(INSTALL_PROGRAM) -m 755 $(CLI) $(DESTDIR)$(bindir)
ifdef SYSTEMD
	$(Q)$(INSTALL_PROGRAM) -d $(DESTDIR)$(unitdir)
	$(Q)$(INSTALL_PROGRAM) -m 644 $(EXEC).service $(DESTDIR)$(unitdir)
	$(Q)$(INSTALL_PROGRAM) -m 644 $(EXEC)-queueing.service $(DESTDIR)$(unitdir)
	$(Q)$(INSTALL_PROGRAM) -m 644 $(EXEC).socket $(DESTDIR)$(unitdir)
endif
	$(Q)$(INSTALL_PROGRAM) -d $(DESTDIR)$(mandir)/man8
	$(Q)$(INSTALL_PROGRAM) -m 644 $(EXEC).8 $(DESTDIR)$(mandir)/man8
	$(Q)$(INSTALL_PROGRAM) -m 644 $(CLI).8 $(DESTDIR)$(mandir)/man8

uninstall:
	$(Q)$(RM) $(DESTDIR)$(bindir)/$(EXEC) $(DESTDIR)$(bindir)/$(CLI)
	$(Q)$(RM) $(DESTDIR)$(mandir)/man8/$(EXEC).8
	$(Q)$(RM) $(DESTDIR)$(mandir)/man8/$(CLI).8
	$(Q)$(RM) $(DESTDIR)$(unitdir)/$(EXEC)-queueing.service
	$(Q)$(RM) $(DESTDIR)$(unitdir)/$(EXEC).service
	$(Q)$(RM) $(DESTDIR)$(unitdir)/$(EXEC).socket

clean: dep_clean
	$(Q)$(RM) core *.o $(EXEC) $(CLI) $(MANPAGES) $(EXEC).service $(EXEC)-queueing.service $(EXEC).socket

include $(wildcard $(OBJS:.o=.d) $(CLI_OBJS:.o=.d))

dep_clean:
	$(Q)$(RM) $(OBJS:.o=.d) $(CLI_OBJS:.o=.d)

=== debian/changelog ===
multipath-tools (0.14.3-2) unstable; urgency=medium

  * [9ef22a2] Run testsuite only during Arch-builds
  * [2a6ef4b] Disable testsuite on loong64

 -- Chris Hofstaedtler <zeha@debian.org>  Mon, 02 Mar 2026 11:49:26 +0100

multipath-tools (0.14.3-1) unstable; urgency=medium

  [ Jonas Jelten ]
  * [d6c9eba] Enable testsuite (LP: #2135118)

  [ Chris Hofstaedtler ]
  * [5c1230c] New upstream version 0.14.3 (Closes: #1128696)
  * [6e2361a] Rebase patches, use WARN_ONLY=1 in make invocation

 -- Chris Hofstaedtler <zeha@debian.org>  Mon, 02 Mar 2026 10:37:01 +0100

=== debian/control ===
Source: multipath-tools
Section: admin
Priority: optional
Maintainer: Debian DM Multipath Team <team+linux-blocks@tracker.debian.org>
Uploaders:
 Guido Günther <agx@sigxcpu.org>,
 Ritesh Raj Sarraf <rrs@debian.org>,
 Chris Hofstaedtler <zeha@debian.org>,
 Fabian Grünbichler <debian@fabian.gruenbichler.email>,
Build-Depends:
 debhelper-compat (= 13),
Build-Depends-Arch:
 libaio-dev,
 libcmocka-dev,
 libdevmapper-dev,
 libedit-dev,
 libjson-c-dev,
 libmount-dev,
 libsystemd-dev,
 libudev-dev,
 liburcu-dev,
 pkgconf,
 systemd-dev,
Vcs-Git: https://salsa.debian.org/linux-blocks-team/multipath-tools.git
Vcs-Browser: https://salsa.debian.org/linux-blocks-team/multipath-tools
Standards-Version: 3.9.8
Homepage: http://christophe.varoqui.free.fr/
Rules-Requires-Root: no
X-Style: black

Package: multipath-tools
Architecture: linux-any
Depends:
 kpartx (>= ${binary:Version}),
 sg3-utils-udev,
# need systemd >= 245 for modprobe@dm_multipath.service
 systemd (>= 245~),
 udev,
 ${misc:Depends},
 ${shlibs:Depends},
Pre-Depends:
 ${misc:Pre-Depends},
Suggests:
 multipath-tools-boot,
Description: maintain multipath block device access
 These tools are in charge of maintaining the disk multipath device maps and
 react to path and map events.
 .
 If you install this package you may have to change the way you address block
 devices. See README.Debian for details.

Package: kpartx
Architecture: linux-any
Depends:
# need dmsetup >= 2:1.02.196-1 to get non-broken DM_UDEV_RULES_VSN in their udev rules
 dmsetup (>= 2:1.02.196-1~),
 udev,
 ${misc:Depends},
 ${shlibs:Depends},
Description: create device mappings for partitions
 Kpartx can be used to set up device mappings for the partitions of any
 partitioned block device.
 .
 It is part of the Linux multipath-tools, but is useful on any
 device-mapper using system.

Package: multipath-tools-boot
Architecture: all
Depends:
 initramfs-tools | linux-initramfs-tool,
 multipath-tools (<< ${source:Version}.1~),
 multipath-tools (>= ${source:Version}),
 ${misc:Depends},
Pre-Depends:
 ${misc:Pre-Depends},
Description: Support booting from multipath devices
 This package contains the necessary support for booting from a multipath
 device:
 .
  * copy over multipath.conf and persistent bindings if necessary
  * load the necessary kernel modules
  * detect multipath block devices
 .
 Don't install this package if you're not booting from a multipath device.

Package: multipath-udeb
Package-Type: udeb
Architecture: linux-any
Depends:
 kpartx-udeb,
 multipath-modules,
 ${misc:Depends},
 ${shlibs:Depends},
Section: debian-installer
Description: maintain multipath block device access - udeb package
 This is a udeb, or a microdeb, for the debian-installer.
 .
 These tools are in charge of maintaining the disk multipath device maps and
 react to path and map events.

Package: kpartx-udeb
Package-Type: udeb
Architecture: linux-any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Section: debian-installer
Description: create device mappings for partitions - udeb package
 This is a udeb, or a microdeb, for the debian-installer.
 .
 Kpartx can be used to set up device mappings for the partitions of any
 partitioned block device. It is part of the Linux multipath-tools.

Package: libmultipath0
Architecture: linux-any
Breaks:
 multipath-tools (<< 0.11.1-3~),
Replaces:
 multipath-tools (<< 0.11.1-3~),
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Section: libs
Description: multipath-tools internal libraries
 This package contains libraries considered internal to the multipath
 system / daemon.
 No package apart from src:multipath-tools is allowed to use symbols
 from libraries shipped by this package.

Package: libmultipath-dev
Architecture: linux-any
Breaks:
 multipath-tools (<< 0.11.1-3~),
Replaces:
 multipath-tools (<< 0.11.1-3~),
Depends:
 libmultipath0 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Section: libdevel
Description: multipath-tools internal libraries - development files
 This package contains the link necessary for dynamically linking
 internal libraries of the multipath system.
 No package apart from src:multipath-tools is allowed to use symbols
 from libraries shipped by this package. The only supported use is
 to allow usage of libmpathcmd-dev and libmpathpersist-dev.

Package: libmpathcmd0
Architecture: linux-any
Breaks:
 multipath-tools (<< 0.11.1-3~),
Replaces:
 multipath-tools (<< 0.11.1-3~),
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Section: libs
Description: multipath command library
 This is the runtime library for submitting commands to the multipath
 system / daemon.

Package: libmpathcmd-dev
Architecture: linux-any
Breaks:
 multipath-tools (<< 0.11.1-3~),
Replaces:
 multipath-tools (<< 0.11.1-3~),
Depends:
 libmpathcmd0 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Section: libdevel
Description: multipath command library - development files
 This package allows development of applications using the command
 library for the multipath system / daemon. It includes headers, libraries
 and links to allow dynamic linking.

Package: libmpathpersist0
Architecture: linux-any
Breaks:
 multipath-tools (<< 0.11.1-3~),
Replaces:
 multipath-tools (<< 0.11.1-3~),
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Section: libs
Description: multipath persist library
 This is the runtime library for managing SCSI persistent reservations
 on multipath devices.

Package: libmpathpersist-dev
Architecture: linux-any
Breaks:
 multipath-tools (<< 0.11.1-3~),
Replaces:
 multipath-tools (<< 0.11.1-3~),
Depends:
 libmpathpersist0 (= ${binary:Version}),
 libmultipath-dev (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Section: libdevel
Description: multipath persist library - development files
 This package allows development of applications using the persistent
 reservation library for multipath devices. It includes headers, libraries
 and links to allow dynamic linking.

Package: libmpathvalid0
Architecture: linux-any
Breaks:
 multipath-tools (<< 0.11.1-3~),
Replaces:
 multipath-tools (<< 0.11.1-3~),
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Section: libs
Description: multipath valid library
 This is the runtime library for checking devices if they are managed
 by the multipath system.

Package: libmpathvalid-dev
Architecture: linux-any
Breaks:
 multipath-tools (<< 0.11.1-3~),
Replaces:
 multipath-tools (<< 0.11.1-3~),
Depends:
 libmpathvalid0 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Section: libdevel
Description: multipath valid library - development files
 This package allows development of applications using the validation
 library for multipath devices. It includes headers, libraries
 and links to allow dynamic linking.

=== debian/rules ===
#!/usr/bin/make -f

# For Hardening
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/buildflags.mk
include /usr/share/dpkg/pkg-info.mk

# Reproducible timestamp
export KBUILD_BUILD_TIMESTAMP = "@$(SOURCE_DATE_EPOCH)"

# Disable libdmmp, no known users exist
export ENABLE_LIBDMMP=0

TREENAMES = build-deb build-udeb

%:
	dh $@

execute_before_dh_clean:
	rm -f debian/libmpathpersist0.symbols
	for treename in $(TREENAMES); do \
		rm -rf debian/$$treename ;\
	done
	# Force recreation of docs re. reproducibility
	rm -fv libdmmp/docs/man/dmmp_strerror.3

execute_before_dh_auto_configure:
	# no out of tree build support, prepare two source trees
	for treename in $(TREENAMES); do \
		mkdir debian/$$treename ;\
		cp -r -t debian/$$treename $$(find . -mindepth 1 -maxdepth 1 \! -name debian \! -name .git) ;\
	done

override_dh_auto_configure:

override_dh_auto_build-indep:

override_dh_auto_build-arch:
	dh_auto_build --sourcedirectory=debian/build-deb -- V=1 WARN_ONLY=1
	# multipath-udeb: build separately; don't reference dynamic libgcc at runtime (#779579); disable systemd
	dh_auto_build --sourcedirectory=debian/build-udeb -- V=1 WARN_ONLY=1 \
		SYSTEMD= EXTRACFLAGS="-static-libgcc"

override_dh_auto_test:
	# on loong64 the test aborts with: loongarch64-linux-gnu-ld.bfd: directio.o: in function libcheck_pending: libmultipath/checkers/directio.c:430: undefined reference to __fxstat
ifneq ($(DEB_HOST_ARCH),loong64)
	dh_auto_test -a --sourcedirectory=debian/build-deb
	dh_auto_test -a --sourcedirectory=debian/build-udeb
endif

override_dh_auto_install-arch:
	dh_auto_install --sourcedirectory=debian/build-deb -- DESTDIR=$(CURDIR)/debian/tmp/deb
	dh_auto_install --sourcedirectory=debian/build-udeb -- DESTDIR=$(CURDIR)/debian/tmp/udeb

	# udebs dont get manpages
	rm -rf $(CURDIR)/debian/tmp/udeb/usr/share/man

	# Delete development files from udebs.
	rm \
		$(CURDIR)/debian/tmp/udeb/usr/include/mpath_cmd.h \
		$(CURDIR)/debian/tmp/udeb/usr/include/mpath_persist.h \
		$(CURDIR)/debian/tmp/udeb/usr/lib/libm*.so

override_dh_auto_install-indep:

execute_after_dh_install:
	if strings debian/multipath-udeb/usr/lib/libmultipath.so.0 | grep libsystemd.so ; then \
		echo ERROR: udeb linked to libsystemd ;\
		exit 1 ;\
	fi

override_dh_bugfiles:
	dh_bugfiles -A -pmultipath-tools -pmultipath-tools-boot

override_dh_installsystemd:
	dh_installsystemd -pmultipath-tools multipathd.service multipathd-queueing.service \
		--no-stop-on-upgrade

debian/libmpathpersist0.symbols: debian/libmpathpersist0.symbols.in
	sed -e 's/$${DEB_VERSION}/${DEB_VERSION}/g' \
		< $< > $@

override_dh_makeshlibs: debian/libmpathpersist0.symbols
	dh_makeshlibs -a --add-udeb=multipath-udeb -- -c4
